Index: palm/trunk/SOURCE/netcdf.f90
===================================================================
--- palm/trunk/SOURCE/netcdf.f90	(revision 262)
+++ palm/trunk/SOURCE/netcdf.f90	(revision 263)
@@ -7,4 +7,5 @@
 ! Current revisions:
 ! ------------------
+! Output of NetCDF messages with aid of message handling routine.
 ! Output of messages replaced by message handling routine.
 !
@@ -187,5 +188,5 @@
           nc_stat = NF90_PUT_ATT( id_set_3d(av), NF90_GLOBAL, 'Conventions', &
                                   'COARDS' )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 62 )
+          CALL handle_netcdf_error( 'netcdf', 62 )
 
           IF ( av == 0 )  THEN
@@ -198,10 +199,10 @@
                                   TRIM( run_description_header ) //    &
                                   TRIM( time_average_text ) )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 63 )
+          CALL handle_netcdf_error( 'netcdf', 63 )
           IF ( av == 1 )  THEN
              WRITE ( time_average_text,'(F7.1,'' s avg'')' )  averaging_interval
              nc_stat = NF90_PUT_ATT( id_set_3d(av), NF90_GLOBAL, 'time_avg', &
                                      TRIM( time_average_text ) )
-             IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 63 )
+             CALL handle_netcdf_error( 'netcdf', 63 )
           ENDIF
 
@@ -210,13 +211,13 @@
           nc_stat = NF90_DEF_DIM( id_set_3d(av), 'time', NF90_UNLIMITED, &
                                   id_dim_time_3d(av) )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 64 )
+          CALL handle_netcdf_error( 'netcdf', 64 )
 
           nc_stat = NF90_DEF_VAR( id_set_3d(av), 'time', NF90_DOUBLE, &
                                   id_dim_time_3d(av), id_var_time_3d(av) )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 65 )
+          CALL handle_netcdf_error( 'netcdf', 65 )
 
           nc_stat = NF90_PUT_ATT( id_set_3d(av), id_var_time_3d(av), 'units', &
                                   'seconds')
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 66 )
+          CALL handle_netcdf_error( 'netcdf', 66 )
 
 !
@@ -225,13 +226,13 @@
           nc_stat = NF90_DEF_DIM( id_set_3d(av), 'zu_3d', nz_do3d-nzb+1, &
                                   id_dim_zu_3d(av) )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 67 )
+          CALL handle_netcdf_error( 'netcdf', 67 )
 
           nc_stat = NF90_DEF_VAR( id_set_3d(av), 'zu_3d', NF90_DOUBLE, &
                                   id_dim_zu_3d(av), id_var_zu_3d(av) )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 68 )
+          CALL handle_netcdf_error( 'netcdf', 68 )
 
           nc_stat = NF90_PUT_ATT( id_set_3d(av), id_var_zu_3d(av), 'units', &
                                   'meters' )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 69 )
+          CALL handle_netcdf_error( 'netcdf', 69 )
 
 !
@@ -239,65 +240,65 @@
           nc_stat = NF90_DEF_DIM( id_set_3d(av), 'zw_3d', nz_do3d-nzb+1, &
                                   id_dim_zw_3d(av) )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 70 )
+          CALL handle_netcdf_error( 'netcdf', 70 )
 
           nc_stat = NF90_DEF_VAR( id_set_3d(av), 'zw_3d', NF90_DOUBLE, &
                                   id_dim_zw_3d(av), id_var_zw_3d(av) )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 71 )
+          CALL handle_netcdf_error( 'netcdf', 71 )
 
           nc_stat = NF90_PUT_ATT( id_set_3d(av), id_var_zw_3d(av), 'units', &
                                   'meters' )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 72 )
+          CALL handle_netcdf_error( 'netcdf', 72 )
 
 !
 !--       Define x-axis (for scalar position)
           nc_stat = NF90_DEF_DIM( id_set_3d(av), 'x', nx+2, id_dim_x_3d(av) )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 73 )
+          CALL handle_netcdf_error( 'netcdf', 73 )
 
           nc_stat = NF90_DEF_VAR( id_set_3d(av), 'x', NF90_DOUBLE, &
                                   id_dim_x_3d(av), id_var_x_3d(av) )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 74 )
+          CALL handle_netcdf_error( 'netcdf', 74 )
 
           nc_stat = NF90_PUT_ATT( id_set_3d(av), id_var_x_3d(av), 'units', &
                                   'meters' )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 75 )
+          CALL handle_netcdf_error( 'netcdf', 75 )
 
 !
 !--       Define x-axis (for u position)
           nc_stat = NF90_DEF_DIM( id_set_3d(av), 'xu', nx+2, id_dim_xu_3d(av) )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 358 )
+          CALL handle_netcdf_error( 'netcdf', 358 )
 
           nc_stat = NF90_DEF_VAR( id_set_3d(av), 'xu', NF90_DOUBLE, &
                                   id_dim_xu_3d(av), id_var_xu_3d(av) )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 359 )
+          CALL handle_netcdf_error( 'netcdf', 359 )
 
           nc_stat = NF90_PUT_ATT( id_set_3d(av), id_var_xu_3d(av), 'units', &
                                   'meters' )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 360 )
+          CALL handle_netcdf_error( 'netcdf', 360 )
 
 !
 !--       Define y-axis (for scalar position)
           nc_stat = NF90_DEF_DIM( id_set_3d(av), 'y', ny+2, id_dim_y_3d(av) )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 76 )
+          CALL handle_netcdf_error( 'netcdf', 76 )
 
           nc_stat = NF90_DEF_VAR( id_set_3d(av), 'y', NF90_DOUBLE, &
                                   id_dim_y_3d(av), id_var_y_3d(av) )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 77 )
+          CALL handle_netcdf_error( 'netcdf', 77 )
 
           nc_stat = NF90_PUT_ATT( id_set_3d(av), id_var_y_3d(av), 'units', &
                                   'meters' )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 78 )
+          CALL handle_netcdf_error( 'netcdf', 78 )
 
 !
 !--       Define y-axis (for v position)
           nc_stat = NF90_DEF_DIM( id_set_3d(av), 'yv', ny+2, id_dim_yv_3d(av) )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 361 )
+          CALL handle_netcdf_error( 'netcdf', 361 )
 
           nc_stat = NF90_DEF_VAR( id_set_3d(av), 'yv', NF90_DOUBLE, &
                                   id_dim_yv_3d(av), id_var_yv_3d(av) )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 362 )
+          CALL handle_netcdf_error( 'netcdf', 362 )
 
           nc_stat = NF90_PUT_ATT( id_set_3d(av), id_var_yv_3d(av), 'units', &
                                   'meters' )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 363 )
+          CALL handle_netcdf_error( 'netcdf', 363 )
 
 !
@@ -310,13 +311,13 @@
                                      (/ id_dim_x_3d(av), id_dim_y_3d(av) /), &
                                      id_var_zusi_3d(av) )
-             IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 413 )
+             CALL handle_netcdf_error( 'netcdf', 413 )
              
              nc_stat = NF90_PUT_ATT( id_set_3d(av), id_var_zusi_3d(av), &
                                      'units', 'meters' )
-             IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 414 )
+             CALL handle_netcdf_error( 'netcdf', 414 )
              
              nc_stat = NF90_PUT_ATT( id_set_3d(av), id_var_zusi_3d(av), &
                                      'long_name', 'zu(nzb_s_inner)' )
-             IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 415 )
+             CALL handle_netcdf_error( 'netcdf', 415 )
 
 !             
@@ -325,13 +326,13 @@
                                      (/ id_dim_x_3d(av), id_dim_y_3d(av) /), &
                                      id_var_zwwi_3d(av) )
-             IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 416 )
+             CALL handle_netcdf_error( 'netcdf', 416 )
              
              nc_stat = NF90_PUT_ATT( id_set_3d(av), id_var_zwwi_3d(av), &
                                      'units', 'meters' )
-             IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 417 )
+             CALL handle_netcdf_error( 'netcdf', 417 )
              
              nc_stat = NF90_PUT_ATT( id_set_3d(av), id_var_zwwi_3d(av), &
                                      'long_name', 'zw(nzb_w_inner)' )
-             IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 418 )
+             CALL handle_netcdf_error( 'netcdf', 418 )
 
           ENDIF             
@@ -422,5 +423,5 @@
              var_list = TRIM( var_list ) // TRIM( do3d(av,i) ) // ';'
 
-             IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 79 )
+             CALL handle_netcdf_error( 'netcdf', 79 )
 !
 !--          Store the 'real' name of the variable (with *, for example)
@@ -429,10 +430,10 @@
              nc_stat = NF90_PUT_ATT( id_set_3d(av), id_var_do3d(av,i), &
                                      'long_name', do3d(av,i) )
-             IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 80 )
+             CALL handle_netcdf_error( 'netcdf', 80 )
 !
 !--          Define the variable's unit
              nc_stat = NF90_PUT_ATT( id_set_3d(av), id_var_do3d(av,i), &
                                      'units', TRIM( do3d_unit(av,i) ) )
-             IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 357 )
+             CALL handle_netcdf_error( 'netcdf', 357 )
 
              i = i + 1
@@ -449,10 +450,10 @@
           nc_stat = NF90_PUT_ATT( id_set_3d(av), NF90_GLOBAL, 'VAR_LIST', &
                                   var_list )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 81 )
+          CALL handle_netcdf_error( 'netcdf', 81 )
 
 !
 !--       Leave NetCDF define mode
           nc_stat = NF90_ENDDEF( id_set_3d(av) )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 82 )
+          CALL handle_netcdf_error( 'netcdf', 82 )
 
 !
@@ -466,5 +467,5 @@
           nc_stat = NF90_PUT_VAR( id_set_3d(av), id_var_x_3d(av), netcdf_data, &
                                   start = (/ 1 /), count = (/ nx+2 /) )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 83 )
+          CALL handle_netcdf_error( 'netcdf', 83 )
 
           DO  i = 0, nx+1
@@ -475,5 +476,5 @@
                                   netcdf_data, start = (/ 1 /),    &
                                   count = (/ nx+2 /) )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 385 )
+          CALL handle_netcdf_error( 'netcdf', 385 )
 
           DEALLOCATE( netcdf_data )
@@ -489,5 +490,5 @@
           nc_stat = NF90_PUT_VAR( id_set_3d(av), id_var_y_3d(av), netcdf_data, &
                                   start = (/ 1 /), count = (/ ny+2 /))
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 84 )
+          CALL handle_netcdf_error( 'netcdf', 84 )
 
           DO  i = 0, ny+1
@@ -498,5 +499,5 @@
                                   netcdf_data, start = (/ 1 /),    &
                                   count = (/ ny+2 /))
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 387 )
+          CALL handle_netcdf_error( 'netcdf', 387 )
 
           DEALLOCATE( netcdf_data )
@@ -507,10 +508,11 @@
                                   zu(nzb:nz_do3d), start = (/ 1 /), &
                                   count = (/ nz_do3d-nzb+1 /) )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 85 )
+          CALL handle_netcdf_error( 'netcdf', 85 )
+
 
           nc_stat = NF90_PUT_VAR( id_set_3d(av), id_var_zw_3d(av),    &
                                   zw(nzb:nz_do3d), start = (/ 1 /), &
                                   count = (/ nz_do3d-nzb+1 /) )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 86 )
+          CALL handle_netcdf_error( 'netcdf', 86 )
 
 
@@ -523,5 +525,5 @@
                                      start = (/ 1, 1 /), &
                                      count = (/ nx+2, ny+2 /) )
-             IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 419 )
+             CALL handle_netcdf_error( 'netcdf', 419 )
 
              nc_stat = NF90_PUT_VAR( id_set_3d(av), id_var_zwwi_3d(av), &
@@ -529,5 +531,5 @@
                                      start = (/ 1, 1 /), &
                                      count = (/ nx+2, ny+2 /) )
-             IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 420 )
+             CALL handle_netcdf_error( 'netcdf', 420 )
 
           ENDIF
@@ -542,5 +544,5 @@
           nc_stat = NF90_GET_ATT( id_set_3d(av), NF90_GLOBAL, 'VAR_LIST', &
                                   var_list_old )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 87 )
+          CALL handle_netcdf_error( 'netcdf', 87 )
 
           var_list = ';'
@@ -571,14 +573,14 @@
 !--       Get and compare the number of vertical gridpoints
           nc_stat = NF90_INQ_VARID( id_set_3d(av), 'zu_3d', id_var_zu_3d(av) )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 88 )
+          CALL handle_netcdf_error( 'netcdf', 88 )
 
           nc_stat = NF90_INQUIRE_VARIABLE( id_set_3d(av), id_var_zu_3d(av), &
                                            dimids = id_dim_zu_3d_old )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 89 )
+          CALL handle_netcdf_error( 'netcdf', 89 )
           id_dim_zu_3d(av) = id_dim_zu_3d_old(1)
 
           nc_stat = NF90_INQUIRE_DIMENSION( id_set_3d(av), id_dim_zu_3d(av), &
                                             len = nz_old )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 90 )
+          CALL handle_netcdf_error( 'netcdf', 90 )
 
           IF ( nz_do3d-nzb+1 /= nz_old )  THEN
@@ -600,14 +602,15 @@
 !--       on the file.
           nc_stat = NF90_INQ_VARID( id_set_3d(av), 'time', id_var_time_3d(av) )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 91 )
+          CALL handle_netcdf_error( 'netcdf', 91 )
 
           nc_stat = NF90_INQUIRE_VARIABLE( id_set_3d(av), id_var_time_3d(av), &
                                            dimids = id_dim_time_old )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 92 )
+          CALL handle_netcdf_error( 'netcdf', 92 )
+
           id_dim_time_3d(av) = id_dim_time_old(1)
 
           nc_stat = NF90_INQUIRE_DIMENSION( id_set_3d(av), id_dim_time_3d(av), &
                                             len = do3d_time_count(av) )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 93 )
+          CALL handle_netcdf_error( 'netcdf', 93 )
 
           nc_stat = NF90_GET_VAR( id_set_3d(av), id_var_time_3d(av), &
@@ -615,5 +618,5 @@
                                   start = (/ do3d_time_count(av) /), &
                                   count = (/ 1 /) )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 94 )
+          CALL handle_netcdf_error( 'netcdf', 94 )
 
           IF ( last_time_coordinate(1) >= simulated_time )  THEN
@@ -638,5 +641,5 @@
              nc_stat = NF90_INQ_VARID( id_set_3d(av), TRIM( do3d(av,i) ), &
                                        id_var_do3d(av,i) )
-             IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 95 )
+             CALL handle_netcdf_error( 'netcdf', 95 )
              i = i + 1
           ENDDO
@@ -646,5 +649,5 @@
           nc_stat = NF90_PUT_ATT( id_set_3d(av), NF90_GLOBAL, 'title', &
                                   TRIM( run_description_header ) )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 96 )
+          CALL handle_netcdf_error( 'netcdf', 96 )
           message_string = 'NetCDF file for volume data ' //             &
                            TRIM( var ) // ' from previous run found.' // &
@@ -658,5 +661,5 @@
           nc_stat = NF90_PUT_ATT( id_set_xy(av), NF90_GLOBAL, 'Conventions', &
                                   'COARDS' )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 97 )
+          CALL handle_netcdf_error( 'netcdf', 97 )
 
           IF ( av == 0 )  THEN
@@ -669,10 +672,10 @@
                                   TRIM( run_description_header ) //    &
                                   TRIM( time_average_text ) )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 98 )
+          CALL handle_netcdf_error( 'netcdf', 98 )
           IF ( av == 1 )  THEN
              WRITE ( time_average_text,'(F7.1,'' s avg'')' )  averaging_interval
              nc_stat = NF90_PUT_ATT( id_set_xy(av), NF90_GLOBAL, 'time_avg', &
                                      TRIM( time_average_text ) )
-             IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 98 )
+             CALL handle_netcdf_error( 'netcdf', 98 )
           ENDIF
 
@@ -681,13 +684,13 @@
           nc_stat = NF90_DEF_DIM( id_set_xy(av), 'time', NF90_UNLIMITED, &
                                   id_dim_time_xy(av) )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 99 )
+          CALL handle_netcdf_error( 'netcdf', 99 )
 
           nc_stat = NF90_DEF_VAR( id_set_xy(av), 'time', NF90_DOUBLE, &
                                   id_dim_time_xy(av), id_var_time_xy(av) )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 100 )
+          CALL handle_netcdf_error( 'netcdf', 100 )
 
           nc_stat = NF90_PUT_ATT( id_set_xy(av), id_var_time_xy(av), 'units', &
                                   'seconds')
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 101 )
+          CALL handle_netcdf_error( 'netcdf', 101 )
 
 !
@@ -707,26 +710,26 @@
 !--       Define vertical coordinate grid (zu grid)
           nc_stat = NF90_DEF_DIM( id_set_xy(av), 'zu_xy', ns, id_dim_zu_xy(av) )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 102 )
+          CALL handle_netcdf_error( 'netcdf', 102 )
 
           nc_stat = NF90_DEF_VAR( id_set_xy(av), 'zu_xy', NF90_DOUBLE, &
                                   id_dim_zu_xy(av), id_var_zu_xy(av) )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 103 )
+          CALL handle_netcdf_error( 'netcdf', 103 )
 
           nc_stat = NF90_PUT_ATT( id_set_xy(av), id_var_zu_xy(av), 'units', &
                                   'meters' )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 104 )
+          CALL handle_netcdf_error( 'netcdf', 104 )
 
 !
 !--       Define vertical coordinate grid (zw grid)
           nc_stat = NF90_DEF_DIM( id_set_xy(av), 'zw_xy', ns, id_dim_zw_xy(av) )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 105 )
+          CALL handle_netcdf_error( 'netcdf', 105 )
 
           nc_stat = NF90_DEF_VAR( id_set_xy(av), 'zw_xy', NF90_DOUBLE, &
                                   id_dim_zw_xy(av), id_var_zw_xy(av) )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 106 )
+          CALL handle_netcdf_error( 'netcdf', 106 )
 
           nc_stat = NF90_PUT_ATT( id_set_xy(av), id_var_zw_xy(av), 'units', &
                                   'meters' )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 107 )
+          CALL handle_netcdf_error( 'netcdf', 107 )
 
 !
@@ -735,13 +738,13 @@
           nc_stat = NF90_DEF_DIM( id_set_xy(av), 'zu1_xy', 1, &
                                   id_dim_zu1_xy(av) )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 108 )
+          CALL handle_netcdf_error( 'netcdf', 108 )
 
           nc_stat = NF90_DEF_VAR( id_set_xy(av), 'zu1_xy', NF90_DOUBLE, &
                                   id_dim_zu1_xy(av), id_var_zu1_xy(av) )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 109 )
+          CALL handle_netcdf_error( 'netcdf', 109 )
 
           nc_stat = NF90_PUT_ATT( id_set_xy(av), id_var_zu1_xy(av), 'units', &
                                   'meters' )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 110 )
+          CALL handle_netcdf_error( 'netcdf', 110 )
 
 !
@@ -750,61 +753,62 @@
           nc_stat = NF90_DEF_VAR( id_set_xy(av), 'ind_z_xy', NF90_DOUBLE, &
                                   id_dim_zu_xy(av), id_var_ind_z_xy(av) )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 111 )
+          CALL handle_netcdf_error( 'netcdf', 111 )
 
           nc_stat = NF90_PUT_ATT( id_set_xy(av), id_var_ind_z_xy(av), 'units', &
                                   'gridpoints')
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 112 )
+          CALL handle_netcdf_error( 'netcdf', 112 )
 
 !
 !--       Define x-axis (for scalar position)
           nc_stat = NF90_DEF_DIM( id_set_xy(av), 'x', nx+2, id_dim_x_xy(av) )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 113 )
+          CALL handle_netcdf_error( 'netcdf', 113 )
 
           nc_stat = NF90_DEF_VAR( id_set_xy(av), 'x', NF90_DOUBLE, &
                                   id_dim_x_xy(av), id_var_x_xy(av) )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 114 )
+          CALL handle_netcdf_error( 'netcdf', 114 )
+
 
           nc_stat = NF90_PUT_ATT( id_set_xy(av), id_var_x_xy(av), 'units', &
                                   'meters' )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 115 )
+          CALL handle_netcdf_error( 'netcdf', 115 )
 
 !
 !--       Define x-axis (for u position)
           nc_stat = NF90_DEF_DIM( id_set_xy(av), 'xu', nx+2, id_dim_xu_xy(av) )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 388 )
+          CALL handle_netcdf_error( 'netcdf', 388 )
 
           nc_stat = NF90_DEF_VAR( id_set_xy(av), 'xu', NF90_DOUBLE, &
                                   id_dim_xu_xy(av), id_var_xu_xy(av) )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 389 )
+          CALL handle_netcdf_error( 'netcdf', 389 )
 
           nc_stat = NF90_PUT_ATT( id_set_xy(av), id_var_xu_xy(av), 'units', &
                                   'meters' )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 390 )
+          CALL handle_netcdf_error( 'netcdf', 390 )
 
 !
 !--       Define y-axis (for scalar position)
           nc_stat = NF90_DEF_DIM( id_set_xy(av), 'y', ny+2, id_dim_y_xy(av) )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 116 )
+          CALL handle_netcdf_error( 'netcdf', 116 )
 
           nc_stat = NF90_DEF_VAR( id_set_xy(av), 'y', NF90_DOUBLE, &
                                   id_dim_y_xy(av), id_var_y_xy(av) )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 117 )
+          CALL handle_netcdf_error( 'netcdf', 117 )
 
           nc_stat = NF90_PUT_ATT( id_set_xy(av), id_var_y_xy(av), 'units', &
                                   'meters' )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 118 )
+          CALL handle_netcdf_error( 'netcdf', 118 )
 
 !
 !--       Define y-axis (for scalar position)
           nc_stat = NF90_DEF_DIM( id_set_xy(av), 'yv', ny+2, id_dim_yv_xy(av) )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 364 )
+          CALL handle_netcdf_error( 'netcdf', 364 )
 
           nc_stat = NF90_DEF_VAR( id_set_xy(av), 'yv', NF90_DOUBLE, &
                                   id_dim_yv_xy(av), id_var_yv_xy(av) )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 365 )
+          CALL handle_netcdf_error( 'netcdf', 365 )
 
           nc_stat = NF90_PUT_ATT( id_set_xy(av), id_var_yv_xy(av), 'units', &
                                   'meters' )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 366 )
+          CALL handle_netcdf_error( 'netcdf', 366 )
 
 !
@@ -817,13 +821,13 @@
                                      (/ id_dim_x_xy(av), id_dim_y_xy(av) /), &
                                      id_var_zusi_xy(av) )
-             IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 421 )
+             CALL handle_netcdf_error( 'netcdf', 421 )
              
              nc_stat = NF90_PUT_ATT( id_set_xy(av), id_var_zusi_xy(av), &
                                      'units', 'meters' )
-             IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 422 )
+             CALL handle_netcdf_error( 'netcdf', 422 )
              
              nc_stat = NF90_PUT_ATT( id_set_xy(av), id_var_zusi_xy(av), &
                                      'long_name', 'zu(nzb_s_inner)' )
-             IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 423 )
+             CALL handle_netcdf_error( 'netcdf', 423 )
 
 !             
@@ -832,13 +836,13 @@
                                      (/ id_dim_x_xy(av), id_dim_y_xy(av) /), &
                                      id_var_zwwi_xy(av) )
-             IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 424 )
+             CALL handle_netcdf_error( 'netcdf', 424 )
              
              nc_stat = NF90_PUT_ATT( id_set_xy(av), id_var_zwwi_xy(av), &
                                      'units', 'meters' )
-             IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 425 )
+             CALL handle_netcdf_error( 'netcdf', 425 )
              
              nc_stat = NF90_PUT_ATT( id_set_xy(av), id_var_zwwi_xy(av), &
                                      'long_name', 'zw(nzb_w_inner)' )
-             IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 426 )
+             CALL handle_netcdf_error( 'netcdf', 426 )
 
           ENDIF
@@ -953,5 +957,5 @@
                 ENDIF
 
-                IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 119 )
+                CALL handle_netcdf_error( 'netcdf', 119 )
 !
 !--             Store the 'real' name of the variable (with *, for example)
@@ -960,10 +964,10 @@
                 nc_stat = NF90_PUT_ATT( id_set_xy(av), id_var_do2d(av,i), &
                                         'long_name', do2d(av,i) )
-                IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 120 )
+                CALL handle_netcdf_error( 'netcdf', 120 )
 !
 !--             Define the variable's unit
                 nc_stat = NF90_PUT_ATT( id_set_xy(av), id_var_do2d(av,i), &
                                         'units', TRIM( do2d_unit(av,i) ) )
-                IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 354 )
+                CALL handle_netcdf_error( 'netcdf', 354 ) 
              ENDIF
 
@@ -981,10 +985,10 @@
           nc_stat = NF90_PUT_ATT( id_set_xy(av), NF90_GLOBAL, 'VAR_LIST', &
                                   var_list )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 121 )
+          CALL handle_netcdf_error( 'netcdf', 121 ) 
 
 !
 !--       Leave NetCDF define mode
           nc_stat = NF90_ENDDEF( id_set_xy(av) )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 122 )
+          CALL handle_netcdf_error( 'netcdf', 122 ) 
 
 !
@@ -1004,5 +1008,5 @@
                                   netcdf_data, start = (/ 1 /),    &
                                   count = (/ ns /) )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 123 )
+          CALL handle_netcdf_error( 'netcdf', 123 )
 
 !
@@ -1018,5 +1022,5 @@
                                   netcdf_data, start = (/ 1 /),    &
                                   count = (/ ns /) )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 124 )
+          CALL handle_netcdf_error( 'netcdf', 124 )
 
 !
@@ -1026,5 +1030,5 @@
                                   netcdf_data, start = (/ 1 /),       &
                                   count = (/ ns /) )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 125 )
+          CALL handle_netcdf_error( 'netcdf', 125 )
 
           DEALLOCATE( netcdf_data )
@@ -1035,5 +1039,5 @@
                                   (/ zu(nzb+1) /), start = (/ 1 /), &
                                   count = (/ 1 /) )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 126 )
+          CALL handle_netcdf_error( 'netcdf', 126 )
 
 !
@@ -1047,5 +1051,5 @@
           nc_stat = NF90_PUT_VAR( id_set_xy(av), id_var_x_xy(av), netcdf_data, &
                                   start = (/ 1 /), count = (/ nx+2 /) )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 127 )
+          CALL handle_netcdf_error( 'netcdf', 127 )
 
           DO  i = 0, nx+1
@@ -1056,5 +1060,5 @@
                                   netcdf_data, start = (/ 1 /),    &
                                   count = (/ nx+2 /) )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 367 )
+          CALL handle_netcdf_error( 'netcdf', 367 )
 
           DEALLOCATE( netcdf_data )
@@ -1070,5 +1074,5 @@
           nc_stat = NF90_PUT_VAR( id_set_xy(av), id_var_y_xy(av), netcdf_data, &
                                   start = (/ 1 /), count = (/ ny+2 /))
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 128 )
+          CALL handle_netcdf_error( 'netcdf', 128 )
 
           DO  i = 0, ny+1
@@ -1079,5 +1083,5 @@
                                   netcdf_data, start = (/ 1 /),    &
                                   count = (/ ny+2 /))
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 368 )
+          CALL handle_netcdf_error( 'netcdf', 368 )
 
           DEALLOCATE( netcdf_data )
@@ -1091,5 +1095,5 @@
                                      start = (/ 1, 1 /), &
                                      count = (/ nx+2, ny+2 /) )
-             IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 427 )
+             CALL handle_netcdf_error( 'netcdf', 427 )
 
              nc_stat = NF90_PUT_VAR( id_set_xy(av), id_var_zwwi_xy(av), &
@@ -1097,5 +1101,5 @@
                                      start = (/ 1, 1 /), &
                                      count = (/ nx+2, ny+2 /) )
-             IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 428 )
+             CALL handle_netcdf_error( 'netcdf', 428 )
 
           ENDIF
@@ -1111,5 +1115,5 @@
           nc_stat = NF90_GET_ATT( id_set_xy(av), NF90_GLOBAL, 'VAR_LIST', &
                                   var_list_old )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 129 )
+          CALL handle_netcdf_error( 'netcdf', 129 )
 
           var_list = ';'
@@ -1152,14 +1156,14 @@
 !--       Get and compare the number of horizontal cross sections
           nc_stat = NF90_INQ_VARID( id_set_xy(av), 'zu_xy', id_var_zu_xy(av) )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 130 )
+          CALL handle_netcdf_error( 'netcdf', 130 )
 
           nc_stat = NF90_INQUIRE_VARIABLE( id_set_xy(av), id_var_zu_xy(av), &
                                            dimids = id_dim_zu_xy_old )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 131 )
+          CALL handle_netcdf_error( 'netcdf', 131 )
           id_dim_zu_xy(av) = id_dim_zu_xy_old(1)
 
           nc_stat = NF90_INQUIRE_DIMENSION( id_set_xy(av), id_dim_zu_xy(av), &
                                             len = ns_old )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 132 )
+          CALL handle_netcdf_error( 'netcdf', 132 )
 
           IF ( ns /= ns_old )  THEN
@@ -1180,5 +1184,5 @@
 
           nc_stat = NF90_GET_VAR( id_set_xy(av), id_var_zu_xy(av), netcdf_data )
-          IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 133 )
+          CALL handle_netcdf_error( 'netcdf', 133 )
 
           DO  i = 1, ns
